<?php
// $Id: gvs.theme.inc,v 1.3 2010/03/26 16:05:04 btomic Exp $
/**
 * @file
 */

/**
 * Implementation of template_preprocess
 */
function template_preprocess_views_view_gvs(&$vars) {

// preprocess css information for the template
  $view = $vars['view'];
  $no_of_rows=count($view->result);
  //dpm($view);
  $basetable=$view->base_table;
  $vars['divh']=$vars['options']['height'];
  $vars['divw']=$vars['options']['width'];

  if ($vars['divh'] == '') $vars['divh']=200;
  if ($vars['divw'] == '') $vars['divw']=300;
  $pattern = "/^([0-9])+$/";
  if (!preg_match($pattern, $vars['divh'])) $vars['divh']=200;
  if (!preg_match($pattern, $vars['divw'])) $vars['divw']=300;

  // Width and height properties for API
  $chartsetting = "'width': " . $vars['options']['width'] . ", 'height': " . $vars['options']['height'] . ", 'title': '" . $vars['options']['title'] . "'";

  // Make DIV instance
  $vars['gvs_id'] = 'gvs-'. $view->name  . '-'. $view->current_display;
  $vars['cwidth'] = $vars['options']['width'];
  $vars['cheight'] = $vars['options']['height'];

  // Color paletes for GeoMap and other charts
  $colorspie[1]=array("'#1d73aa'", "'#c44441'", "'#8cbc4f'", "'#7a5892'", "'#009ab2'", "'#f48533'", "'#8baad1'");
  $colorspie[2]=array("'#003DF5'", "'#6633FF'", "'#CC33FF'", "'#FF33CC'", "'#3366FF'", "'#33CCFF'", "'#C3D9FF'", "'#002EB8'", "'#FF3366'", "'#33FFCC'", "'#B88A00'", "'#F5B800'", "'#FF6633'", "'#33FF66'", "'#66FF33'", "'#CCFF33'", "'#FFCC33'");
  $colorspie[3]=array("'#a12c21'", "'#e74d24'", "'#f37121'", "'#f6f5bc'", "'#f7f9e4'", "'#f89728'", "'#fec246'", "'#ffe38d'");
  $colorspie[4]=array("'#00fa2c'", "'#00dd25'", "'#00bf1f'", "'#00a06a'", "'#007d10'", "'#005908'", "'002e02'", "'#000d10'");
  $colorspie[5]=array("'#FF1A00'", "'#CC0000'", "'#FF7400'", "'#008C00'", "'#006E2E'", "'#4096EE'", "'#FF0084'");
  $colorspie[6]=array("'#B02B2C'", "'#D15600'", "'#C79810'", "'#73880A'", "'#6BBA70'", "'#3F4C6B'", "'#356AA0'", "'#D01F3C'");
  $colorspie[7]=array("'#d81f26'", "'#f15d51'", "'#f7a396'", "'#fde2db'", "'#dde9ec'", "'#88cadd'", "'#0092c2'", "'#144a90'");

  $colorsmap[1]=array(0x1d73aa, 0xc44441, 0x8cbc4f, 0x7a5892, 0x009ab2, 0xf48533, 0x8baad1);
  $colorsmap[2]=array(0x3366FF, 0x6633FF, 0xCC33FF, 0xFF33CC, 0x33CCFF, 0xC3D9FF, 0x003DF5, 0x002EB8, 0xFF3366, 0x33FFCC, 0xB88A00, 0xF5B800, 0xFF6633, 0x33FF66, 0x66FF33, 0xCCFF33, 0xFFCC33);
  $colorsmap[3]=array(0xa12c21, 0xe74d24, 0xf37121, 0xf6f5bc, 0xf7f9e4, 0xf89728, 0xfec246, 0xffe38d);
  $colorsmap[4]=array(0x00fa2c, 0x00dd25, 0x00bf1f, 0x00a06a, 0x007d10, 0x005908, 0x002e02, 0x000d10);
  $colorsmap[5]=array(0xFF1A00, 0xCC0000, 0xFF7400, 0x008C00, 0x006E2E, 0x4096EE, 0xFF0084);
  $colorsmap[6]=array(0xB02B2C, 0xD15600, 0xC79810, 0x73880A, 0x6BBA70, 0x3F4C6B, 0x356AA0, 0xD01F3C);
  $colorsmap[7]=array(0xd81f26, 0xf15d51, 0xf7a396, 0xfde2db, 0xdde9ec, 0x88cadd, 0x0092c2, 0x144a90);

  if ($vars['options']['color']!='')
    if ($vars['options']['type']!='7')
      $chartsetting .= ",'colors':[" . implode(',', $colorspie[$vars['options']['color']]) . "]";
    else
      $chartsetting .= ",'colors':[" . implode(",", $colorsmap[$vars['options']['color']]) . "]";

  // Generate appropriate js code for different type of charts
  switch ($vars['options']['type']) {
    case '0':
      // PieChart
      $constructor='PieChart';
      if ($vars['options']['is3D'])
        $chartsetting .= ", 'is3D': true";
      else
        $chartsetting .= ", 'is3D': false";
      if ($vars['options']['pieJoinAngle'] !='') $chartsetting .=",pieJoinAngle:".$vars['options']['pieJoinAngle'];
      if ($vars['options']['pieMinimalAngle'] !='') $chartsetting .=",pieMinimalAngle:".$vars['options']['pieMinimalAngle'];

      $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');data.addColumn('number','" . $vars['options']['yaxis1'] . "');
                data.addRows(" . $no_of_rows . ");";
      $xfield=$view->field[$vars['options']['xaxis']]->field_alias;
      $yfield=$view->field[$vars['options']['yaxis1']]->field_alias;
      for ($j=0;$j<$no_of_rows;$j++) {
        $xvalue=$view->result[$j]->$xfield;
        $yvalue=$view->result[$j]->$yfield;
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" . $xvalue . "'") . ");";
        $strdata .= "data.setValue(" . $j . ", 1, " . (is_null($yvalue)?'undefined':$yvalue) . ");";
      }
      break;
    case '1':
      // Gauge
      $constructor='Gauge';
      $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');data.addColumn('number','" . $vars['options']['yaxis1'] . "');
                data.addRows(" . $no_of_rows . ");";
      $xfield=$view->field[$vars['options']['xaxis']]->field_alias;
      $yfield=$view->field[$vars['options']['yaxis1']]->field_alias;
      for ($j=0;$j<$no_of_rows;$j++) {
        $xvalue=$view->result[$j]->$xfield;
        $yvalue=$view->result[$j]->$yfield;
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" . $xvalue . "'") . ");";
        $strdata .= "data.setValue(" . $j . ", 1, " . (is_null($yvalue)?'undefined':$yvalue) . ");";
      }
      break;
    case '2':
      // BarChart
      $constructor='BarChart';
      if ($vars['options']['is3D'])
        $chartsetting .= ", is3D: true";
      else
        $chartsetting .= ", is3D: false";
      if ($vars['options']['linlog']=='log')
        $chartsetting .= ", 'logScale': true";
      if ($vars['options']['isStacked'])
        $chartsetting .= ", 'isStacked': true";

      $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');";
      for ($jj=1; $jj<6; $jj++) {
        if ($vars['options']['yaxis' . $jj] != '')
          $strdata .= "data.addColumn('number','" . $vars['options']['yaxis' . $jj] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0; $j<$no_of_rows; $j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field_alias;
        $xvalue=$view->result[$j]->$xfield;
        $strdata .= "data.setValue(" . $j . ", 0, " . ( is_null($xvalue) ? 'undefined' : "'" . $xvalue . "'" ) . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ( $vars['options']['yaxis' . $jj] != '' ) {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '3':
      // AreaChart
      $constructor='AreaChart';
      if ($vars['options']['linlog']=='log')
        $chartsetting .= ", 'logScale': true";
      if ($vars['options']['isStacked'])
        $chartsetting .= ", 'isStacked': true";

      $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $vars['options']['yaxis' . $jj] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field_alias;
        $xvalue=$view->result[$j]->$xfield;
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" . $xvalue . "'") . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '4':
      // ColumnChart
      $constructor='ColumnChart';
      if ($vars['options']['is3D'])
        $chartsetting .= ", is3D: true";
      else
        $chartsetting .= ", is3D: false";
      if ($vars['options']['linlog']=='log')
        $chartsetting .= ", 'logScale': true";
      if ($vars['options']['isStacked'])
        $chartsetting .= ", 'isStacked': true";

      $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $vars['options']['yaxis' . $jj] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field_alias;
        $xvalue=$view->result[$j]->$xfield;
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" . $xvalue . "'") . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '5':
      // LineChart
      $constructor='LineChart';
      if ($vars['options']['linlog']=='log')
        $chartsetting .= ", 'logScale': true";

      $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $vars['options']['yaxis' . $jj] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field_alias;
        $xvalue=$view->result[$j]->$xfield;
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" . $xvalue . "'") . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '6':
      // ScatterChart
      $constructor='ScatterChart';
      if ($vars['options']['linlog']=='log')
        $chartsetting .= ", 'logScale': true";

      $strdata="data.addColumn('number','" . $vars['options']['xaxis1'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $vars['options']['yaxis' . $jj] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis1']]->field_alias;
        $xvalue=$view->result[$j]->$xfield;
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':$xvalue) . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '7':
      // GeoMap
      $constructor='GeoMap';
      $chartsetting .= ", region:'" . $vars['options']['region1'] . "', dataMode:'" . $vars['options']['geomaptype'] . "'";
      $no_of_cols=array();
      if ($vars['options']['geomaptype']==='region') {
        $strdata="data.addColumn('string','" . $vars['options']['geomapstring'] . "');";
        $no_of_cols[]='geomapstring';
        if ($vars['options']['yaxis1']!='') {
          $strdata .= "data.addColumn('number','" . $vars['options']['yaxis1'] . "');";
          $no_of_cols[]='yaxis1';
        }
        if ($vars['options']['xaxis']!='') {
          $strdata .= "data.addColumn('string','" . $vars['options']['xaxis'] . "');";
          $no_of_cols[]='xaxis';
        }
      }
      else {
        if ($vars['options']['geomaplat']!='' && $vars['options']['geomaplon']!='') {
          $strdata="data.addColumn('number','" . $vars['options']['geomaplat'] . "');";
          $no_of_cols[]='geomaplat';
          $strdata .= "data.addColumn('number','" . $vars['options']['geomaplon'] . "');";
          $no_of_cols[]='geomaplon';
          if ($vars['options']['yaxis1']!='') {
            $strdata .= "data.addColumn('number','" . $vars['options']['yaxis1'] . "');";
            $no_of_cols[]='yaxis1';
          }
          if ($vars['options']['xaxis']!='') {
            $strdata .= "data.addColumn('string','" . $vars['options']['xaxis'] . "');";
            $no_of_cols[]='xaxis';
          }
        }
        else {
          if ($vars['options']['geomapstring']!='') {
            $strdata="data.addColumn('string','" . $vars['options']['geomapstring'] . "');";
            $no_of_cols[]='geomapstring';
            if ($vars['options']['yaxis1']!='') {
              $strdata .= "data.addColumn('number','" . $vars['options']['yaxis1'] . "');";
              $no_of_cols[]='yaxis1';
            }
            if ($vars['options']['xaxis']!='') {
              $strdata .= "data.addColumn('string','" . $vars['options']['xaxis'] . "');";
              $no_of_cols[]='xaxis';
            }
          }
          else
            $strdata='Error';
        }
      }

      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++)
        for ($jj=0;$jj<count($no_of_cols);$jj++) {
          $xfield=$view->field[$vars['options'][$no_of_cols[$jj]]]->field_alias;
          $xvalue=$view->result[$j]->$xfield;
          if ($no_of_cols[$jj]=='yaxis1' || $no_of_cols[$jj]=='geomaplat' || $no_of_cols[$jj]=='geomaplon')
            $strdata .= "data.setValue(" . $j . "," . $jj . "," . (is_null($xvalue)?'undefined':$xvalue) . ");";
          else {
            if ($no_of_cols[$jj]=='xaxis') $xvalue=strtoupper($xvalue);
            $strdata .= "data.setValue(" . $j . "," . $jj . "," . (is_null($xvalue)?'undefined':"'" . $xvalue . "'") . ");";
          }
        }
      break;
    case '8':
      // Intensity Map
      $constructor='IntensityMap';
      $chartsetting .= ", region:'" . $vars['options']['region'] . "'";
      $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $vars['options']['yaxis' . $jj] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $jjj=1;
        $xfield=$view->field[$vars['options']['xaxis']]->field_alias;
        $xvalue=$view->result[$j]->$xfield;
        $strdata .= "data.setValue(" . $j . ", 0, " . (is_null($xvalue)?'undefined':"'" . $xvalue . "'") . ");";
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '9':
      // Motion Chart
      $chartsetting='';
      if (!$vars['options']['showChartButtons']) $chartsetting .=",showChartButtons:false";
      if (!$vars['options']['showHeader']) $chartsetting .=",showHeader:false";
      if (!$vars['options']['showSelectListComponent']) $chartsetting .=",showSelectListComponent:false";
      if (!$vars['options']['showSidePanel']) $chartsetting .=",showSidePanel:false";
      if (!$vars['options']['showXMetricPicker']) $chartsetting .=",showXMetricPicker:false";
      if (!$vars['options']['showYMetricPicker']) $chartsetting .=",showYMetricPicker:false";
      if (!$vars['options']['showXScalePicker']) $chartsetting .=",showXScalePicker:false";
      if (!$vars['options']['showYScalePicker']) $chartsetting .=",showYScalePicker:false";
      if (!$vars['options']['showAdvancedPanel']) $chartsetting .=",showAdvancedPanel:false";
      if ($vars['options']['state'] !='') $chartsetting .=",state:'".$vars['options']['state']."'";

      $constructor='MotionChart';
      $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');";
      $strdata .= "data.addColumn('date','" . $vars['options']['yaxis11'] . "');";
      for ($jj=2;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $vars['options']['yaxis' . $jj] . "');";
      }
      for ($jj=2;$jj<6;$jj++) {
        if ($vars['options']['zaxis' . $jj]!='')
          $strdata .= "data.addColumn('string','" . $vars['options']['zaxis' . $jj] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $xfield=$view->field[$vars['options']['xaxis']]->field_alias;
        $xvalue=$view->result[$j]->$xfield;
        $yfield=$view->field[$vars['options']['yaxis11']]->field_alias;
        $yvalue=$view->result[$j]->$yfield;
        $strdata .= "data.setValue(" . $j . ", 0," . (is_null($xvalue)?'undefined':"'" . $xvalue . "'") . ");";

        if (is_null($yvalue))
          $strdata .= "data.setValue(" . $j . ", 1, undefined);";
        else {
          if (preg_match("/^(\d{4})-(\d{2})-(\d{2}) ([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9])$/", $yvalue))
            $yvaluedate = strtotime($yvalue);
          else
            $yvaluedate = $yvalue;
          $strdata .= "data.setValue(" . $j . ", 1, new Date (" . date('Y', $yvaluedate) . "," . date('m', $yvaluedate) . "," . date('d', $yvaluedate) . "));";
        }

        $jjj=2;
        for ($jj=2;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$view->field[$vars['options']['yaxis' . $jj]]->field_alias;
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
        for ($jj=2;$jj<6;$jj++) {
          if ($vars['options']['zaxis' . $jj]!='') {
            $zfield=$view->field[$vars['options']['zaxis' . $jj]]->field_alias;
            $zvalue=$view->result[$j]->$zfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($zvalue)?'undefined':"'" . $zvalue . "'") . ");";
            $jjj++;
          }
        }
      }
      break;
    case '10':
      // AnnotatedTimeLine - not implemented
      $constructor='AnnotatedTimeLine';
      $chartsetting="'displayAnnotations': true";
      $strdata="data.addColumn('date','" . $vars['options']['yaxis11'] . "');";
      for ($jj=1;$jj<6;$jj++) {
        if ($vars['options']['yaxis' . $jj]!='')
          $strdata .= "data.addColumn('number','" . $vars['options']['yaxis' . $jj] . "');";
      }
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $yfield=$vars['options']['yaxis11'];
        $yvalue=$view->result[$j]->$yfield;
        if (is_null($yvalue))
          $strdata .= "data.setValue(" . $j . ", 1, undefined);";
        else {
          if (preg_match("/^(\d{4})-(\d{2})-(\d{2}) ([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9])$/", $yvalue))
            $yvaluedate = strtotime($yvalue);
          else
            $yvaluedate = $yvalue;
          $strdata .= "data.setValue(" . $j . ", 0, new Date (" . date('Y', $yvaluedate) . "," . date('m', $yvaluedate) . "," . date('d', $yvaluedate) . "));";
        }

        $jjj=1;
        for ($jj=1;$jj<6;$jj++) {
          if ($vars['options']['yaxis' . $jj]!='') {
            $yfield=$vars['options']['yaxis' . $jj];
            $yvalue=$view->result[$j]->$yfield;
            $strdata .= "data.setValue(" . $j . ", " . $jjj . ", " . (is_null($yvalue)?'undefined':$yvalue) . ");";
            $jjj++;
          }
        }
      }
      break;
    case '11':
      $constructor='Map';
      $chartsetting="'showTip': true,'enableScrollWheel':true,'showLine':false,'mapType':'" . $vars['options']['maptype'] . "'";
      $strdata="data.addColumn('number','" . $vars['options']['geomaplat1'] . "');";
      $strdata .= "data.addColumn('number','" . $vars['options']['geomaplon1'] . "');";
      $strdata .= "data.addColumn('string','" . $vars['options']['geomapstring'] . "');";
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $field=$view->field[$vars['options']['geomaplat1']]->field_alias;
        $value=$view->result[$j]->$field;
        $strdata .= "data.setValue(" . $j . ",0," . (is_null($value)?'undefined':$value) . ");";
        $field=$view->field[$vars['options']['geomaplon1']]->field_alias;
        $value=$view->result[$j]->$field;
        $strdata .= "data.setValue(" . $j . ",1," . (is_null($value)?'undefined':$value) . ");";
        $field=$view->field[$vars['options']['geomapstring']]->field_alias;
        $value=$view->result[$j]->$field;
        $strdata .= "data.setValue(" . $j . ",2," . (is_null($value)?'undefined':"'" . $value . "'") . ");";
      }

      break;
    case '12':
      // Term Cloud - not implemented
      $chartsetting='';
      $constructor='TermCloud';
      $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');";
      $strdata .= "data.addColumn('number','" . $vars['options']['yaxis1'] . "');";
      if ($vars['options']['zaxis2']!='')
        $strdata .= "data.addColumn('string','" . $vars['options']['zaxis2'] . "');";
      $strdata .= "data.addRows(" . $no_of_rows . ");";
      for ($j=0;$j<$no_of_rows;$j++) {
        $field=$view->field[$vars['options']['xaxis']]->field_alias;
        $value=$view->result[$j]->$field;
        $strdata .= "data.setValue(" . $j . ",0," . (is_null($value)?'undefined':"'" . $value . "'") . ");";
        $field=$view->field[$vars['options']['yaxis1']]->field_alias;
        $value=$view->result[$j]->$field;
        $strdata .= "data.setValue(" . $j . ",1," . (is_null($value)?'undefined':$value) . ");";
        if ($vars['options']['zaxis2']!='') {
          $field=$view->field[$vars['options']['zaxis2']]->field_alias;
          $value=$view->result[$j]->$field;
          $strdata .= "data.setValue(" . $j . ",2," . (is_null($value)?'undefined':"'" . $value . "'") . ");";
        }
      }
      break;
    case '13':/*
            $chartsetting='';
            $constructor='TermCloud';
            $strdata="data.addColumn('string','" . $vars['options']['xaxis'] . "');";
            $strdata.="data.addColumn('number','" . $vars['options']['yaxis1'] . "');";
            if ($vars['options']['zaxis2']!='')
                $strdata.="data.addColumn('string','" . $vars['options']['zaxis2'] . "');";
            $strdata.="data.addRows(" . $no_of_rows . ");";
            for ($j=0;$j<$no_of_rows;$j++){
                $field=$view->field[$vars['options']['xaxis']]->field_alias;
                $value=$view->result[$j]->$field;
                $strdata.="data.setValue(" . $j . ",0," . (is_null($value)?'undefined':"'" . $value . "'") . ");";
                $field=$view->field[$vars['options']['yaxis1']]->field_alias;
                $value=$view->result[$j]->$field;
                $strdata.="data.setValue(" . $j . ",1," . (is_null($value)?'undefined':$value) . ");";
                if ($vars['options']['zaxis2']!=''){
                    $field=$view->field[$vars['options']['zaxis2']]->field_alias;
                    $value=$view->result[$j]->$field;
                    $strdata.="data.setValue(" . $j . ",2," . (is_null($value)?'undefined':"'" . $value . "'") . ");";
                }
            }*/
      break;
  }

//Additional settings
  if (in_array($vars['options']['type'], array(0, 2, 3, 4, 5, 6))){
    if ($vars['options']['legendBackgroundColor'] !='') $chartsetting .=",legendBackgroundColor:'".$vars['options']['legendBackgroundColor']."'";
    if ($vars['options']['legendFontSize'] !='') $chartsetting .=",legendFontSize:".$vars['options']['legendFontSize'];
    if ($vars['options']['legendTextColor'] !='') $chartsetting .=",legendTextColor:'".$vars['options']['legendTextColor']."'";
    if ($vars['options']['backgroundColor'] !='') $chartsetting .=",backgroundColor:'".$vars['options']['backgroundColor']."'";
    if ($vars['options']['borderColor'] !='') $chartsetting .=",borderColor:'".$vars['options']['borderColor']."'";
    if ($vars['options']['titleColor'] !='') $chartsetting .=",titleColor:'".$vars['options']['titleColor']."'";
    if ($vars['options']['titleFontSize'] !='') $chartsetting .=",titleFontSize:".$vars['options']['titleFontSize'];
    if ($vars['options']['axisColor'] !='') $chartsetting .=",axisColor:'".$vars['options']['axisColor']."'";
    if ($vars['options']['axisBackgroundColor'] !='') $chartsetting .=",axisBackgroundColor:'".$vars['options']['axisBackgroundColor']."'";
    if ($vars['options']['axisFontSize'] !='') $chartsetting .=",axisFontSize:".$vars['options']['axisFontSize'];
    $chartsetting .=",legend:'".$vars['options']['legend']."'";
    if ($vars['options']['enableTooltip'] == '1') $chartsetting .=",enableTooltip:true"; else $chartsetting .=",enableTooltip:false";
  }
  if (in_array($vars['options']['type'], array(2, 3, 4, 5, 6))){
    if ($vars['options']['titleX'] !='') $chartsetting .=",titleX:'".$vars['options']['titleX']."'";
    if ($vars['options']['titleY'] !='') $chartsetting .=",titleY:'".$vars['options']['titleY']."'";
   }

  // Generate some necessary js code for Google Viz API
  $typepackages=strtolower($constructor);
  $api_key = variable_get('gvs_api_key', False);

  if ($vars['options']['type']=='7' && $vars['options']['geomaptype']=='markers')
    if ($api_key) {
      $gvs_gmap_gapi="http://maps.google.com/maps?file=api&v=2&key=" . $api_key;
      drupal_set_html_head('<script type="text/javascript" src="'. $gvs_gmap_gapi  . '"></script>');
    }
    else
      drupal_set_message('Enter Google maps key in Gmap settings');

  if ($vars['options']['type']=='11')
    if ($api_key) {
      $gvs_gmap_gapi="http://maps.google.com/maps?file=api&v=2&key=" . $api_key;
      drupal_set_html_head('<script type="text/javascript" src="'. $gvs_gmap_gapi  . '"></script>');
    }
    else
      drupal_set_message('Enter Google maps key in Gmap settings');

  if ($vars['options']['type']!='13') {
    $gvs_gapi="http://www.google.com/jsapi";
    drupal_set_html_head('<script type="text/javascript" src="'. $gvs_gapi  . '"></script>');
    if ($vars['options']['type']!='12')
      drupal_set_html_head("<script type=\"text/javascript\">google.load('visualization', '1', {'packages':['" . $typepackages . "']});</script>");
    $inlinet="function drawChart(){var data = new google.visualization.DataTable();var chart;";
    $inlinet .= $strdata;
    $inlinet .= "chart = new google.visualization . " . $constructor . "(document.getElementById('" . $vars['gvs_id'] . "'));
                chart.draw(data, {" . $chartsetting . "});}
                google.setOnLoadCallback(drawChart);";
  }
  else {
    dpm($api_key);
    if ($api_key) {
      $gvs_gmap_gapi="http://www.google.com/jsapi?key=" . $api_key;
      drupal_set_html_head('<script type="text/javascript" src="'. $gvs_gmap_gapi  . '"></script>');
    }
    else
      drupal_set_message('Enter Google maps key in Gmap settings');
    $inlinet='google.load("earth", "1");var ge = null;function init(){google.earth.createInstance("' . $vars['gvs_id'] . '", initCallback, failureCallback)};
                function initCallback(object){ge = object;ge.getWindow().setVisibility(true);ge.getNavigationControl().setVisibility(ge.VISIBILITY_AUTO);}
                function failureCallback(object) {}
                google.setOnLoadCallback(init);';
  }
  // Add code to template
  drupal_add_js($inlinet, 'inline');
}

/**
 * Overridable theme function.
 * This functions prints a warning when no data is available.
 */
function theme_gvs_nodata() {
  drupal_set_message(t('There is no data available'), 'warning');
}
